3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value. i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
13 if [[ $SHELLOPTS = *xtrace* ]]; then
18 # Assume that lbuild's support files can be found in the same
19 # canonicalized path as this very script.
20 LBUILD_SCRIPT=$(readlink -f ${0})
21 LBUILD_DIR=${LBUILD_DIR:-$(dirname ${LBUILD_SCRIPT})}
23 # include the exit_traps library
24 . ${LBUILD_DIR}/exit_traps.sh
25 . ${LBUILD_DIR}/funcs.sh
27 # our children should die when we do
28 push_exit_trap "kill -INT -$$ || true" kill_children
30 # increment this if you have made a change that should force a new kernel
33 #BUILD_GEN=2 # bz19952: remove -lustre tag from kernel RPM names
34 #BUILD_GEN=3 # bz19975: enable the building of src.rpms by default
35 #BUILD_GEN=4 # bz22281: use the git hash in the kernel extra version
36 #BUILD_GEN=5 # TT-107: don't cache the BUILD dir
37 BUILD_GEN=6 # TT-1092: don't cache the BUILD dir, to rebuild external OFED
45 # XXX - some recent hacking has pretty much neutered this option.
46 # search through this file for "-bb" and see how many places
47 # simply don't account for this option
52 TARGET_ARCH="$(uname -m)"
53 # change default behavior to only build for the current arch
54 TARGET_ARCHS="$TARGET_ARCH"
55 TARGET_ARCHS_ALL="$TARGET_ARCH"
56 [ "$TARGET_ARCH" = "i686" ] && TARGET_ARCHS_ALL="i686 i586 i386"
61 TMPDIR=${TMPDIR:-"/var/tmp"}
63 # this is the dir that should be used to store reuse products
65 # should cached products be used or force rebuilding?
67 # what does this do exactly? does it imply no kernel build?
71 SMPTYPES="smp bigsmp default ''"
78 # default to not adding -lustre- into the kernel RPM package names
79 KERNEL_LUSTRE_NAMING=false
80 # default not use kabi check.
98 # not in the target file any more
101 # build the lustre-tests rpm?
108 # Readlink is not present on some older distributions: emulate it.
112 if [ -L "$path" ]; then
113 ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
122 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
124 --external-patches=EXTERNAL_PATCHES
125 Directory similar to lustre/lustre/kernel_patches/ that lbuild should
126 look for seres and config files in before looking in the lustre
129 --extraversion=EXTRAVERSION
130 Text to use for the rpm release and kernel extraversion.
132 --timestamp=TIMESTAMP
133 Date of building lustre in format YYYYMMDDhhmmss
136 Try to reuse old kernel builds from DIR
139 Path to distro kernel RPM collection
148 Build lustre client only
151 Which distro using. Autodetect by default
153 --kerneldir=KERNELDIR
154 Directory containing Linux source tarballs referenced by target
157 --kerneltree=KERNELTREE
158 Directory containing dirs with Linux source tarballs referenced by target
159 files. Dir names in format kernel version ('2.6.9', etc.)
161 --linux=LINUX --with-linux=LINUX
162 Directory of Linux kernel sources. When this option is used, only
163 Lustre modules and userspace are built.
166 Path to an existing lustre source tarball to use.
169 Do not try to download a kernel from downloads.hpdd.intel.com
172 Do not build a .src.rpm, a full kernel patch, or a patched kernel
176 Build with ldiskfs support. (Deprecated, always true)
179 Do not build lustre-iokit RPM. Now true by default
185 Specifies that the files generated do not include timestamps, and
186 that this is an official release.
189 Build Lustre without ZFS.
192 Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
195 Directory used to stage packages for release. RPMs will be placed
196 more or less in DIR/<target>-<arch>, and the tarball will be
200 The name of the target to build. The available targets are listed
203 --target-archs=TARGET_ARCHS
204 A (space delimited) list of architectures to build. By default,
205 all of the archs supported by the TARGET will be built, in
206 addition to a .src.rpm. This option can limit those, for machines
207 that can only build certain archs or if you only want a certain
208 arch built (for testing, or a one-off kernel).
210 Also note that by using a non-"base" arch (eg, i386) only kernels
211 will be built - there will be no lustre-lite-utils package.
214 Builds a Xen domX kernel.
217 Sets a variable to a given value.
226 # canonicalize a relative path to a file
230 if [ ! -f "$PATH" ]; then
234 local FILE=${PATH##*/}
237 echo $(canon_path "$DIR")/$FILE
241 # canonicalize a relative path to a dir
245 if [ ! -d "$PATH" ]; then
249 pushd "$PATH" >/dev/null || return 1
259 if [ -z "$LUSTRE" -o ! -r "$LUSTRE" ]; then
260 usage 1 "Could not find Lustre source tarball '$LUSTRE'."
263 if [ -z "$DISTRO" ] ; then
264 DISTRO=$(autodetect_distro)
268 DISTROMAJ=${DISTRO%%.*}
270 [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
272 if [ -z "$LINUX" ]; then
273 [ "$KERNELDIR" -o "$KERNELTREE" ] || \
274 usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
276 [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
277 usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
279 # TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
280 # [ -r "$TARGET_FILE" ] || \
281 # usage 1 "Target '$TARGET' was not found."
286 CANONICAL_TARGET="sles12"
289 CANONICAL_TARGET="rhel7"
292 CANONICAL_TARGET="rhel6"
295 CANONICAL_TARGET="rhel5"
298 CANONICAL_TARGET="rhel-2.6"
301 CANONICAL_TARGET="sles-2.6"
304 CANONICAL_TARGET="sles10-2.6"
306 2.6-sles11 | 3.0-sles11)
307 CANONICAL_TARGET="sles11"
310 CANONICAL_TARGET="oel5"
313 CANONICAL_TARGET="hp-pnnl-2.4"
321 CANONICAL_TARGET="$TARGET"
325 local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
326 [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
327 local timestamplength="${#TIMESTAMP}"
328 if [ $timestamplength -eq 12 ]; then
329 TIMESTAMP="${TIMESTAMP}00"
330 elif [ $timestamplength -ne 14 ]; then
331 TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
334 local RPMBUILD=$(which rpmbuild 2>/dev/null | head -n 1)
335 RPMBUILD=${RPMBUILD:-$(which rpm 2>/dev/null | head -n 1)}
336 if [ -z "$RPMBUILD" ]; then
337 usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
340 local BINDIR="$TOPDIR/bin"
341 if [ -d $BINDIR ]; then
342 rm -rf $BINDIR >/dev/null 2>&1 || true
345 mkdir -p $BINDIR || fatal 1 "error trying to create $BINDIR"
346 export PATH=$BINDIR:$PATH
348 cat >${BINDIR}/rpmbuild <<EOF
351 ARGS="\${FIND_REQUIRES:+--define \"__find_requires \$FIND_REQUIRES\"}"
354 *\'* ) ARGS="\$ARGS \"\$arg\"" ;;
355 * ) ARGS="\$ARGS '\$arg'" ;;
359 eval $RPMBUILD \$ARGS
361 chmod 755 ${BINDIR}/rpmbuild
363 if [ -n "$CCACHE" ]; then
364 which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
366 if which "$CCACHE" &>/dev/null; then
367 local ccache=$(which "$CCACHE" 2>/dev/null | head -n 1)
369 ln -s "$ccache" ${BINDIR}/ccache
370 ln -s "$ccache" ${BINDIR}/cc
371 ln -s "$ccache" ${BINDIR}/$CC
374 export CC="ccache $CC"
375 # zero the cache so we can see how effective we are being with it
379 # get some ccache stats when we are done
380 push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
381 # should remove the ccache trap if lbuild is interrupted
382 trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
389 # compare two versions $1 and $2. if $1 < $2, return 0 otherwise return 1.
391 [[ $1 == $2 ]] && return 1
393 local i val1=($1) val2=($2)
395 # padding zero to val1 if it needs
396 for ((i=${#val1[@]}; i<${#val2[@]}; i++)); do
399 for ((i=0; i<${#val1[@]}; i++)); do
400 [[ -z ${val2[i]} ]] && return 1
402 if [[ ${val1[i]} < ${val2[i]} ]]; then
404 elif [[ ${val1[i]} > ${val2[i]} ]]; then
414 echo $(echo "$*" | xargs -n 1 | sort -u)
422 if [ -z "$target" ]; then
423 fatal 1 "fetch_url() called without a target to fetch to"
426 if [ -d $target ]; then
427 target+="/${url##*/}"
431 if which wget >/dev/null 2>&1; then
432 if ! wget -nv "$url" -O "$target"; then
435 elif which curl >/dev/null 2>&1; then
436 if ! curl -n -L -s -o "$target" "$url"; then
440 fatal 1 "Could not find either wget or curl to fetch URLs."
450 local force="${3:-false}"
452 if $force || [ ! -r "$KERNELDIR/$srpm" ] ||
453 [ ! -s "$KERNELDIR/$srpm" ]; then
455 local location="https://downloads.hpdd.intel.com/public/kernels/$target/old"
456 # get the location from a distro specific method if it exists
457 if type -p kernel_srpm_location; then
458 location=$(kernel_srpm_location)
460 echo "Downloading $location/$srpm..."
461 if ! fetch_url "$location/$srpm" "$KERNELDIR/$srpm" 2>&1 ||
462 [ ! -s "$KERNELDIR/$srpm" ]; then
463 rm -f $KERNELDIR/$srpm
464 # punt to a distro specific method if it exists
465 if ! type -p download_srpm-$DISTROMAJ; then
466 fatal 1 "Could not download target $target's kernel SRPM $srpm from $location."
468 if ! download_srpm-$DISTROMAJ "$target" "$srpm" "$force"; then
469 fatal 1 "Could not download target $target's kernel SRPM $srpm using download_srpm-$DISTROMAJ."
474 fatal 1 "$srpm not found in directory $KERNELDIR."
485 local file=${from##*/}
491 local semaphore="$to-downloading"
494 if [ ! -f $semaphore ]; then
498 # make sure the download has not been aborted
499 local now=$(date +%s)
500 local file_mtime=$(stat -c %Y "$to")
501 local staleness=$((now - file_mtime))
502 # let's assume an active download will write at least once a minute
503 if [ $staleness -gt 60 ]; then
511 # if the semaphore file exists, the file is either still downloading
512 # or a download was aborted and we cannot trust the target file
513 if [ -f $semaphore ]; then
517 if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
524 if $force || ! is_downloaded; then
525 if is_downloading; then
526 echo "Somebody else is downloading $from..."
527 while is_downloading; do
528 echo "Waiting for $to to finish downloading"
531 if is_downloaded; then
534 echo "The download we were waiting for seems to have been aborted"
540 echo "Downloading $from..."
541 # flag others so they don't try to download also
542 push_exit_trap "rm -f $to $semaphore" "download"
544 if ! fetch_url "$from" "$to" || [ ! -s "$to" ]; then
545 # the trap will remove the files via the fatal below
546 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
549 delete_exit_trap "download"
551 fatal 1 "${to##*/} not found in directory ${to%/*}."
560 local force="${1:-false}"
562 if [ -z "$OFED_VERSION" -o "$OFED_VERSION" = "inkernel" ]; then
566 local OFED_BASE_VERSION=$OFED_VERSION
567 if [[ $OFED_VERSION = *.*.*.* ]]; then
568 OFED_BASE_VERSION=${OFED_VERSION%.*}
571 local location="https://www.openfabrics.org/downloads/OFED/ofed-${OFED_BASE_VERSION}/"
573 if [[ $OFED_VERSION = *-[rR][cC][0-9] ]]; then
575 Mmv=${OFED_VERSION%%-[rR][cC][0-9]}
576 location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}/"
579 if [[ $OFED_VERSION = daily-* ]]; then
581 Mmv=${OFED_VERSION/daily-/}
582 daily=${OFED_VERSION##$Mmv-}
583 location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
584 # find the filename for the version for the date specified
585 OFED_VERSION=$(curl -s "$location" | sed -nre "/${Mmv}-/s/.*href=\"OFED-(${Mmv}-[0-9]{8,8}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
586 if [ -z "$OFED_VERSION" ]; then
587 fatal 1 "Could not determine the filename of the OFED snapshot for ${daily}"
591 local file="OFED-${OFED_VERSION}.tgz"
592 download_file "$location/$file" "$KERNELTREE" "$force"
598 EXTRA_VERSION_save="$EXTRA_VERSION"
599 for patchesdir in "$EXTERNAL_PATCHES" \
600 "$TOPDIR/lustre/lustre/kernel_patches"; do
601 TARGET_FILE="$patchesdir/targets/$TARGET.target"
602 [ -r "$TARGET_FILE" ] && break
604 [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
606 echo "Loading target config file $TARGET.target..."
608 # if the caller specified an OFED_VERSION it should override whatever
609 # the target file specifies
610 local env_OFED_VERSION="$OFED_VERSION"
614 if [ -n "$env_OFED_VERSION" ]; then
615 OFED_VERSION="$env_OFED_VERSION"
618 # doesn't make any sense to build OFED for xen domX's
623 # XXX - set_rpm_smp_type is an ugly undeterministic hack. it needs to
624 # go away and the target just specify the $RPMSMPTYPE
625 [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
627 # CC might have been overwritten in TARGET_FILE
628 if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
629 export CCACHE && export CC="ccache $CC"
632 if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
633 KERNELDIR="$KERNELTREE/${lnxmaj}"
634 [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
637 # verify the series is available
638 if [ "$SERIES" ]; then
639 for series in $SERIES; do
640 for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
641 [ -r "$patchesdir/series/$series" ] && continue 2
643 fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
647 # set the location of the .config file
653 if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
654 CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
657 local lnxrelnew=${lnxrel//-/_}
659 # remember the EXTRA_VERSION before we diddle it here
660 # XXX - we really should not diddle with any values read in from the
661 # target file. if we want to modify a value, we should create
663 PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
665 if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
666 fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
669 if [ "$EXTRA_VERSION_save" ]; then
670 EXTRA_VERSION="$EXTRA_VERSION_save"
671 elif ! $RELEASE; then
672 # if there is no patch series, then this is not a lustre specific
673 # kernel. don't make it look like one
674 if $PATCHLESS || [ -n "$SERIES" ]; then
675 EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
678 # EXTRA_VERSION=${EXTRA_VERSION//-/_}
680 ALL_ARCHS="$BASE_ARCHS $BIGMEM_ARCHS $BOOT_ARCHS $JENSEN_ARCHS $SMP_ARCHS $BIGSMP_ARCHS $PSERIES64_ARCHS $UP_ARCHS"
683 for arch in $(uniqify "$ALL_ARCHS"); do
684 if [ -z "$TARGET_ARCHS" ] ||
685 [[ \ $TARGET_ARCHS\ = *\ $arch\ * ]]; then
686 BUILD_ARCHS="$BUILD_ARCHS $arch"
689 [ "$BUILD_ARCHS" ] || usage 1 "No available target archs to build."
690 echo "Building for: $BUILD_ARCHS"
696 echo -n '--wildcards '
699 fatal 1 "tarflags(): File name argument missing."
711 fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
720 local extractfile="$@"
722 echo "Untarring ${tarfile##*/}..."
723 tar $(tarflags "$tarfile") "$tarfile" $extractfile
729 if ! untar "$KERNELTREE/OFED-${OFED_VERSION}.tgz"; then
732 [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
738 untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
739 [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
745 local do_patch=${1:-true}
747 FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
748 [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
749 $do_patch && pushd linux >/dev/null
750 for series in $SERIES; do
751 echo -n "Applying series $series:"
752 for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
753 [ -r "$patchesdir/series/$series" ] || continue
754 SERIES_FILE="$patchesdir/series/$series"
755 for patch in $(<"$SERIES_FILE"); do
757 PATCH_FILE="$patchesdir/patches/$patch"
758 [ -r "$PATCH_FILE" ] || \
759 fatal 1 "Patch $patch does not exist in Lustre tree."
760 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
762 fatal 1 "Error adding patch $patch to full patch."
765 patch -s -p1 < "$PATCH_FILE" 2>&1 || {
767 fatal 1 "Error applying patch $patch."
775 $do_patch && popd >/dev/null
776 echo "Full patch has been saved in ${FULL_PATCH##*/}."
783 local configure_args=""
787 pushd lustre >/dev/null
789 if ! build_lustre_dkms; then
790 popd >/dev/null # pushd lustre
794 echo "Building Lustre RPMs for: $BUILD_ARCHS..."
796 # If server we now build the spl and zfs modules against the lustre kernel.
797 # These are required prior to the building of lustre server. Client does
798 # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
799 # line above so is at least consistant.
800 if [ $PATCHLESS == false ] && [ "x$WITH_ZFS" == "x" ]; then
801 if ! build_spl_zfs; then
802 popd >/dev/null # pushd lustre
808 configure_args="$configure_args --disable-server"
811 # ditto for the lustre-tests boolean
812 if ! $LUSTRE_TESTS; then
813 configure_args="$configure_args --disable-tests"
817 configure_args="$configure_args --disable-iokit"
820 if ! $OSDZFSRPM; then
821 configure_args="$configure_args --without-zfs"
824 if ! $OSDLDISKFSRPM; then
825 configure_args="$configure_args --disable-ldiskfs"
828 configure_args="$configure_args --with-linux=$linux"
829 configure_args="$configure_args ${linuxobj:+--with-linux-obj=$linuxobj}"
831 # allow environment setting to override ldiskfs series selection
832 [ -n "$LDISKFS_SERIES" ] && export LDISKFS_SERIES
834 ./configure $configure_args $CONFIGURE_FLAGS 2>&1 ||
835 fatal 1 "Error in configure."
837 fatal 1 "Error building rpms for $BUILD_ARCHS."
839 # move RPMs into place where they are expected to be
840 for arch in $BUILD_ARCHS; do
841 mv -f lustre-*.${arch}.rpm $TOPDIR/RPMS/${arch}/
843 mv -f lustre-*.src.rpm $TOPDIR/SRPMS/
850 # Only zfs Lustre DKMS Server is supported
851 build_lustre_dkms() {
853 local name_prefix="lustre"
854 local ver=$(sed -n -e 's/^LUSTRE_VERSION = //p' LUSTRE-VERSION-FILE)
856 echo "Building Lustre DKMS RPMs for: $BUILD_ARCHS..."
857 ./configure --enable-dist || fatal 1 "Error in DKMS configure."
860 build_args="--without servers"
861 name_prefix="lustre-client"
864 rpmbuild --define "_topdir $TOPDIR" $build_args -bs lustre-dkms.spec ||
865 fatal 1 "Error building DKMS .src.rpm for $BUILD_ARCHS."
866 rpmbuild --define "_topdir $TOPDIR" $build_args \
867 --rebuild $TOPDIR/SRPMS/$name_prefix-dkms-$ver-*.src.rpm ||
868 fatal 1 "Error building DKMS .rpm for $BUILD_ARCHS."
876 # Fetch spl/zfs from the git repo and prepare for lustre build
879 # SPLZFSGITREPO - URI of directory where spl.git and zfs.git are located
880 # SPLZFSTAG - Tag to checkout of clone repositories
881 # SPLZFSVER - Version to checkout of both (format zfs/spl-$SPLZFSVER)
883 # return 0 if successful, else 255
885 # make sure the RPM build environment is set up
890 # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
891 # destination for the rpms
892 export RPM_BUILD_ROOT=$TOPDIR
893 SPLZFSVER=${SPLZFSVER:-0.6.4.2}
894 SPLZFSTAG=${SPLZFSTAG:-}
896 # The files expect a kver to be set to the kernel version .
897 local kver=$(find_linux_release)
899 # build and install the spl and zfs (and -devel) RPMs for lustre to use
901 for pkg in spl zfs; do
905 [ "$pkg" == "zfs" ] && spldir="$(ls -d $TOPDIR/usr/src/spl-*/|tail -1)"
907 # need to fetch the repo in order to build it.
908 # default to github but allow override
909 git clone ${SPLZFSGITREPO:-"https://github.com/zfsonlinux"}/$pkg.git $pkg 2>&1
911 pushd $pkg || return 255
912 if [ -n "$SPLZFSTAG" ]; then
913 git checkout $SPLZFSTAG
915 git checkout -b lbuild $pkg-$SPLZFSVER
918 # This differentiates between older zfs versions
919 if [ -f $pkg-modules.spec.in ]; then
922 speclist="$pkg.spec $rpmpkg.spec"
924 rpmpkg=kmod-$pkg-devel
926 speclist="$pkg.spec $pkg-kmod.spec $pkg-dkms.spec"
929 sh autogen.sh || return 255
931 if ! ./configure --with-linux=${LINUX} --with-linux-obj=${LINUXOBJ:-$LINUX} \
932 ${spldir:+--with-spl="${spldir}"} 2>&1 ||
933 ! make dist 2>&1; then
939 ln -f $pkg/$pkg-*.tar.gz $TOPDIR/SOURCES ||
940 error "failed to link $pkg/$pkg-*.tar.gz into $TOPDIR/SOURCES"
941 if [ -f $pkg/scripts/kmodtool ]; then
942 ln -f $pkg/scripts/kmodtool $TOPDIR/SOURCES/
952 # set search dir for our own kmodtool to find correct
954 export KERNELSOURCE=$(dirname ${LINUX})
955 # Manually build rpms
956 for spec in $speclist; do
957 echo "Building RPMs from $pkg/$specdir/$spec"
958 if ! rpmbuild $rpmb $pkg/$specdir/$spec \
960 --define "require_kdir ${LINUX}" \
961 ${LINUXOBJ:+--define "require_kobj ${LINUXOBJ}"} \
962 ${spldir:+--define "require_spldir ${spldir}"} \
963 --define "kver $kver" \
964 --define "kernels $kver" \
965 --define "_tmppath /var/tmp" \
966 --define "kernelbuildroot $TOPDIR/reused" \
967 --define "_topdir $TOPDIR" 2>&1; then
972 # We have built the rpms for the package. Now we need to extract the
973 # contained files so we can build further things against them
974 local rpms=$(ls -1 $TOPDIR/RPMS/*/$rpmpkg-*.rpm)
976 # cpio only extract to pwd so we need to go there.
980 rpm2cpio $rpm | cpio -id
983 if [ "$pkg" == "zfs" ]; then
984 # We also need to extract both the zfs and zfs-devel rpms
985 # the zfs rpm is needed because it has the actual libraries in
986 # it and the zfs-devel rpm only has unversioned symlinks to the
987 # libraries in the zfs rpm
988 # this will all change one day when we have a libzfs rpm per
989 # https://github.com/zfsonlinux/zfs/issues/2329
990 # and it looks like it could be one day soon:
991 # https://github.com/zfsonlinux/zfs/pull/2341
992 local devel_rpms=$(ls -1 $TOPDIR/RPMS/*/{$pkg-devel,$pkg-$SPLZFSVER,lib*}-*.rpm)
993 for rpm in $devel_rpms; do
994 rpm2cpio $rpm | cpio -id
996 CONFIGURE_FLAGS="--with-$pkg-devel=$TOPDIR ${CONFIGURE_FLAGS}"
1000 CONFIGURE_FLAGS="--with-$pkg=$(ls -d $TOPDIR/usr/src/$pkg-*/|tail -1) ${CONFIGURE_FLAGS}"
1001 CONFIGURE_FLAGS="--with-$pkg-obj=$(ls -d $TOPDIR/usr/src/$pkg-*/$kver*|tail -1) ${CONFIGURE_FLAGS}"
1011 [ "$STAGEDIR" ] || return 0
1013 for arch in $BUILD_ARCHS; do
1014 rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${arch}"
1015 echo "${0##*/}: Copying RPMs into ${rpmdir}"
1016 mkdir -p "${rpmdir}"
1017 for rpm in $(ls RPMS/${arch}/*.rpm RPMS/noarch/*.rpm); do
1018 cp -v $rpm "${rpmdir}"
1022 cp -v "$LUSTRE" "$STAGEDIR"
1026 set_rpm_smp_type() {
1028 local infact_arch="${TARGET_ARCH}"
1031 [ "$infact_arch" == "i586" ] && infact_arch="i686"
1034 for smp_type in $SMP_ARCHS; do
1035 [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
1038 for smp_type in $BIGSMP_ARCHS; do
1039 [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
1042 for smp_type in $PPC64_ARCHS; do
1043 [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
1046 for smp_type in $DEFAULT_ARCHS; do
1047 [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
1052 # This function takes a linux include tree and digs out the linux release
1053 # from it. It is never called directly, only called from the distro
1054 # specific function find_linux_release() in lbuild-{rhel,sles}.
1055 _find_linux_release() {
1057 local LINUXRELEASEHEADER=""
1059 LINUXRELEASEHEADER=$SRC/include/linux/version.h
1060 if [ -s $SRC/include/generated/utsrelease.h ]; then
1061 LINUXRELEASEHEADER=$SRC/include/generated/utsrelease.h
1062 elif [ -s $SRC/include/linux/utsrelease.h ]; then
1063 LINUXRELEASEHEADER=$SRC/include/linux/utsrelease.h
1066 if [ ! -s $LINUXRELEASEHEADER ]; then
1067 fatal 1 "could not find UTS_RELEASE"
1070 sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
1073 # unpack kernel(/source/devel) RPM
1075 # This function and it's setting of $LINUX and $LINUXOBJ is a total hack that
1076 # needs to completely refactored. It completely ingores that $BUILD_ARCHS may
1077 # contain a list of arches for which rpmbuild commands (including the one for
1079 unpack_linux_devel_rpm() {
1080 local kernelrpm="${1}"
1082 [ -f "$kernelrpm" ] || return 255
1083 [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1085 pushd $TOPDIR/reused &>/dev/null || return 255
1087 if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1091 # call a distro specific hook, if available
1092 if type -p unpack_linux_devel_rpm-$DISTROMAJ; then
1093 if ! unpack_linux_devel_rpm-$DISTROMAJ "$kernelrpm"; then
1100 find_linux_devel_paths $TOPDIR/reused
1108 local kib_prefix="$2"
1111 # build kernel-ib{,-devel}/compat-rdma{,-devel}
1113 # ofed 1.3 had a bug in the rpm spec
1114 if [ "$OFED_VERSION" = "1.3" ]; then
1118 local OFED_CORE="--with-core-mod --with-ipoib-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod"
1119 local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod --with-qib-mod"
1121 if compare_version $OFED_VERSION 3.0; then
1122 OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
1124 OFED_HARDWARE="$OFED_HARDWARE --with-mlx5-mod --with-cxgb4-mod --with-ocrdma-mod --with-qib-mod"
1127 # some I/B drivers are architecture dependent and kernel-ib's configure
1128 # does not figure it out for us ~sigh~
1129 case "$TARGET_ARCH" in
1131 OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1134 # we're no longer shipping the OFED iSCSI target
1135 #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1136 OFED_ISCSI="--with-srp-mod"
1137 ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1138 ##kernels >= 2.6.30)
1139 #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1140 # OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1143 # assume we are just rebuilding the SRPM
1144 local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1145 local SOURCE="${TOPDIR}/OFED/SRPMS/${kib_prefix}-*.src.rpm"
1147 # but switch to building from the SPEC if we need to apply patches
1148 if ls ${TOPDIR}/lustre/contrib/patches/ofed/* >/dev/null; then
1150 rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1151 SOURCE="${TOPDIR}/SPECS/${kib_prefix}.spec"
1152 local file ed_fragment1 ed_fragment2 n=1
1153 for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.patch); do
1154 ed_fragment1="$ed_fragment1
1155 Patch$n: ${file%%*/}"
1156 ed_fragment2="$ed_fragment2
1158 cp $file ${TOPDIR}/SOURCES
1161 for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.ed); do
1162 # Only apply the ed-scripts that should be used for the canonical target
1163 # ed-files in ${TOPDIR}/lustre/contrib/patches/ofed/ have to follow the naming
1165 # <two-digits>-<descriptive-name>:<canonical_target_1>: ...:<canonical_target_N>.ed
1166 # To apply the same change to multiple canonical target simply specify
1167 # a list of colon separated canoncial target names in the file name.
1168 echo "$file" | grep -q -e ":${CANONICAL_TARGET}:" \
1169 -e ":${CANONICAL_TARGET}.ed$"
1170 if [ $? -eq 0 ] ; then
1171 ed_fragment3="$ed_fragment3
1177 if [ $n -gt 1 ]; then
1191 local linuxrelease=$(find_linux_release)
1192 if compare_version $OFED_VERSION 3.0; then
1193 local OFA_KERNEL_RELEASE=$(echo -n ${linuxrelease} | sed -e 's/-/_/g')
1195 if ! rpmbuild $BUILD_TYPE --define 'build_kernel_ib 1' --define 'build_kernel_ib_devel 1' \
1196 --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1197 --define "KVERSION ${linuxrelease}" \
1198 --define "$K_SRC ${linux}" \
1199 --define "LIB_MOD_DIR /lib/modules/${linuxrelease}/updates" \
1200 ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1201 --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1202 ${SOURCE} 2>&1; then
1203 fatal 1 "Error building ${kib_rpm}"
1212 local signature="$4"
1213 local use_links="$5"
1220 local default_iface=$(/sbin/ip route get 192.1.1.1 | sed -ne 's/.* dev \(.*\) * src .*/\1/p')
1221 if [ -z "$default_iface" ]; then
1222 fatal 1 "Failed to determine the default route interface"
1224 local unique_id=$(/sbin/ip addr show dev $default_iface | sed -ne '/ inet /s/ *inet \(.*\)\/.*/\1/p' | head -1)
1225 if [ -z "$unique_id" ]; then
1226 fatal 1 "Failed to determine a unique id from interface $default_interface"
1229 local finallocation="$location"/"$signature"/"$module"
1230 location="$location"/"$signature-${unique_id}"/"$module"
1231 mkdir -p "$location"
1232 # the cleanup script removes any directory that doesn't have a
1233 # .lastused, so let's try to prevent that as soon as we can
1234 # this solution still slightly racy with the cleanup script
1235 # but the race is a lot tighter now
1236 touch -t 197001010000 "$location/.lastused"
1237 ## use eval/echo here to make sure shell expansions are performed
1238 #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1240 for article in $(eval echo $articles); do
1241 if ! cp -a${linkflag} "$article" "$location"; then
1242 error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1243 # rename the cache location so that it's not cached
1244 # product, but is around for analysis
1245 mv "$location"{,-bad-$(date +%s)} ||
1246 error "failed to clean up a failed cache attempt" \
1247 "in \"$location\" -- manual cleanup will be" \
1253 # flag the cache as complete (i.e. in case lbuild was previously
1254 # interrupted while caching)
1255 touch "$location/.lastused"
1257 # put the temporary location into the final location
1259 mkdir -p "${finallocation%/*}"
1260 mv "$location" "$finallocation"
1261 rmdir "${location%/*}"
1269 local use_links="${3:-false}"
1270 local signature="$4"
1272 if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1273 if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1274 # the .lastused flag is populated at the end of the caching to
1275 # signal that the caching was completed. if that flag is not
1276 # there, then the cache is invalid (and should be removed in fact)
1277 mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1278 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1282 # so that we know how stale this entry is
1283 touch $REUSEBUILD/$signature/$module/.lastused
1286 if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1287 cp -al $REUSEBUILD/$signature/$module/* $dest/
1290 # copying is pretty heavy
1291 # cp -a $REUSEBUILD/$signature/$module/* $dest/
1292 # do some creative symlinking instead
1294 for dir in BUILD SRPMS SPECS; do
1295 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1296 ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1299 # sources have to be copied by file because we need SOURCES to
1300 # be a dir we can write into
1301 # could overrun ls's arg list here
1302 #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1303 find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1304 xargs ln -t $dest/SOURCES -s
1306 # same for RPMS/* dirs
1307 # could overrun ls's arg list here
1308 #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1310 for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1311 mkdir -p $dest/RPMS/${dir##*/}
1313 xargs ln -t $dest/RPMS/${dir##*/} -s
1325 if [[ $arch = i[3456]86 ]]; then
1333 build_kernel_with_srpm() {
1336 if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1337 fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1340 # need to generate the patch for this target
1341 do_patch_linux false >&${outfd} # sets global $FULL_PATCH (yeah, yuck)
1343 # get an md5sum of the kernel patch + config for reuse check
1344 # XXX really, there needs to be a signature and a CONFIG_FILE per arch
1348 local release_str="RELEASE=$RELEASE\n"
1351 if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1352 local REUSE_SIGNATURE=$({ echo -en $release_str;
1355 cat "$TARGET_FILE" |
1356 sed -e '/_VERSION=/s/_[0-9]*_g.*$//g';
1358 cat "$LBUILD_DIR/lbuild";
1359 cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1360 md5sum | cut -d" " -f1)
1361 # see if we can link to the reuse pool
1362 # XXX - hrm. i'm not convinced this doesn't belong in the reuse
1364 local CAN_LINK_FOR_REUSE=false
1365 touch $REUSEBUILD/$$
1366 if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1367 CAN_LINK_FOR_REUSE=true
1372 # the extra version string to use for the kernel (which might be a reused
1374 local kernel_extra_version=""
1375 if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1376 "$REUSE_SIGNATURE"; then
1377 # nothing cached, build from scratch
1378 if [ ! -r "$KERNELDIR/$KERNEL_SRPM" ]; then
1379 echo "Downloading kernel SRPM" >&${outfd}
1380 download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1383 if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1384 --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1385 # should we clean this up or leave it for analysis?
1387 fatal 1 "Error installing kernel SRPM."
1390 # put the Lustre kernel patch into the RPM build tree
1391 cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1392 prepare_and_build_srpm >&${outfd} ||
1393 fatal 1 "failed to prepare_and_build_srpm"
1395 if [ -z "$REUSE_SIGNATURE" ]; then
1396 echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1398 # store the resulting kernel RPM build tree for future use
1399 echo "Storing the built kernel for future reuse" >&${outfd}
1400 if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,SRPMS,RPMS}" \
1401 "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1402 "$CAN_LINK_FOR_REUSE"; then
1403 error "Failed to store kernel RPMS for reuse"
1404 echo "unknown" >&${outfd}
1410 # figure out the EXTRA_VERSION of the kernel we built or are re-using
1412 if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel(-default)? ="); then
1413 fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1415 kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1417 # should now have the following RPMs
1418 # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1419 # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1420 # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1421 # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1422 # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1424 echo $kernel_extra_version
1432 # REUSEBUILD, USE_BUILD_CACHE
1437 local ofed_version="$2"
1441 # if an ofed version is given, then it means use OFED proper,
1442 # not any vendor specific "inkernel" version
1443 if [ -z "$ofed_version" ]; then
1447 if [ "$ofed_version" = "inkernel" ]; then
1448 # see if there is a distro specific override for this and use
1450 # XXX we need to better integrate a distro specific override with
1451 # the rest of this function so that all of the reuse cache
1452 # stuff is leveraged given that 80% of this function is reuse
1453 if type -p build_ofed-$DISTROMAJ; then
1455 ofed_location=$(build_ofed-$DISTROMAJ ${STDOUT})
1456 local rc=${PIPESTATUS[0]}
1457 CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1462 elif compare_version $OFED_VERSION 3.0; then
1463 kib_prefix="ofa_kernel"
1466 kib_prefix="compat-rdma"
1467 kib_rpm="compat-rdma"
1470 # build kernel-ib/compat-rdma
1471 if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1472 local REUSE_SIGNATURE=$({ echo "$ofed_version";
1473 echo "$(find_linux_release;
1474 echo "$BUILD_GEN")";
1475 cat "${linux}/include/linux/autoconf.h";
1476 cat "$LBUILD_DIR/lbuild";
1477 cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1478 md5sum | cut -d" " -f1)
1479 # see if we can link to the reuse pool
1480 # XXX - hrm. i'm not convinced this doesn't belong in the reuse
1482 local CAN_LINK_FOR_REUSE=false
1483 touch $REUSEBUILD/$$
1484 if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1485 CAN_LINK_FOR_REUSE=true
1490 if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1491 "$REUSE_SIGNATURE"; then
1492 if [ -n "$REUSE_SIGNATURE" ]; then
1493 # stash away the existing built articles for a moment
1495 mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1498 find . | cpio -pudlm ..
1502 create_rpmbuild_dirs
1505 build_kernel_ib "${linux}" "${kib_prefix}" "${kib_rpm}"
1507 if [ -z "$REUSE_SIGNATURE" ]; then
1508 echo "No reuse signature was caculated so not storing the built ofed"
1510 # store the resulting RPM build tree for future use
1511 echo "Storing the built ofed for future reuse"
1512 if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1513 "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1514 "$CAN_LINK_FOR_REUSE"; then
1515 error "Failed to store OFED RPMS for reuse"
1519 # put the stuff we stashed away back
1524 pushd "$TOPDIR" >/dev/null
1525 rm -rf ${kib_rpm}-devel
1526 mkdir ${kib_rpm}-devel
1528 # the actual ofed RPMs don't have the -rc$n or -$date string appened that
1529 # might be present on the file
1530 #local linuxrelease=$(find_linux_release)
1531 #ofed_version=$(echo $ofed_version |
1532 # sed -re 's/-(20[0-9]{6,6}-[0-9]{4,4}|rc[0-9]*)$//')
1534 # OFED version will have 'hyphen' for minor release. (e.g. 3.5-1, instead
1535 # of 3.5.1) compat-rdma and compat-rdma-devel could have same version
1536 # number, but currectly not. Once OFED fix this in the future release, we
1537 # can remove following filter.
1538 #ofed_version=$(echo $ofed_version |
1539 # sed -re 's/-([0-9]*-[rR][cC][0-9]*)$//')
1540 #local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version}-${linuxrelease//-/_}.*.rpm)
1541 # I dont' know why we have gone through the trouble to filter out the name
1542 # of the rpm there should only be one ${kib_rpm}-devel built
1543 local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-*.rpm)
1544 if ! rpm2cpio < $rpm | cpio -id; then
1545 fatal 1 "could not unpack the ${kib_rpm}-devel rpm."
1547 CONFIGURE_FLAGS="--with-o2ib=$(pwd)/usr/src/${kib_prefix} ${CONFIGURE_FLAGS}"
1554 if ! $PATCHLESS; then
1555 local kernel_extra_version
1556 if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1557 fatal 1 "Failed to build the kernel from it's SRPM"
1560 for arch in $BUILD_ARCHS; do
1561 local kernel_devel_rpm
1562 if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/$arch/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1563 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/$arch/"
1566 # install the -devel RPM in preparation for modules builds
1567 if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1568 "$TOPDIR/RPMS/$arch/$kernel_devel_rpm"; then
1569 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/$arch/$kernel_devel_rpm"
1573 # need to find and unpack the vendor's own kernel-devel for patchless
1576 if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1577 fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1579 if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1580 fatal 1 "Could not find the Linux tree in $kernelrpm"
1584 # ~sigh~ have to make copies of and modify some of the rpm
1585 # infrastructure files so that find-requires can find our unpacked
1586 # kernel-devel artifacts
1587 cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1588 export FIND_REQUIRES="$(pwd)/find-requires"
1589 chmod 755 {symset-table,find-requires{,.ksyms}}
1591 tmp="${tmp//\//\\/}"
1592 ed find-requires <<EOF
1596 /|.*find-requires.ksyms/s/|/| bash -x/
1597 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1600 ed find-requires.ksyms <<EOF
1604 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1607 ed symset-table <<EOF
1611 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1612 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1616 build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1617 fatal 1 "error building OFED"
1620 if build_lustre "$LINUX" "$LINUXOBJ"; then
1621 # the build worked. resolve any symlinked files (i.e. from reuse)
1622 # in RPMS/$arch to real files so that that that huge mess of
1623 # complication known as LTS can copy them yet somewhere else.
1624 # is it any wonder this whole process is so damn so? anyone ever
1625 # heard of hardlinks? it's this cool new thing that allows you save
1626 # tons of time and space by creating... well you can go read about
1627 # them if you have not heard about them yet.
1628 # can i say how much the implemenation of all of this really impedes
1631 for dir in RPMS/*; do
1633 for file in $(ls); do
1634 if [ -h $file ]; then
1641 # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1642 # as that's where LTS expects to find them
1643 for dir in RPMS/*; do
1644 if [ $dir = RPMS/$TARGET_ARCH ]; then
1649 if [ -n "$files" ]; then
1650 cp -al $files ../$TARGET_ARCH
1660 create_rpmbuild_dirs() {
1662 [ -d RPMS ] || mkdir RPMS
1663 for arch in $BUILD_ARCHS; do
1664 if [[ $arch = i?86 ]]; then
1665 # some stupidity in the sles11 kernel spec requires an RPMS/i386
1666 # even if the target arch is i686
1667 [ -d RPMS/i386 ] || mkdir RPMS/i386
1669 [ -d RPMS/$arch ] || mkdir RPMS/$arch
1671 [ -d RPMS/noarch ] || mkdir RPMS/noarch
1672 [ -d BUILD ] || mkdir BUILD
1673 [ -d SOURCES ] || mkdir SOURCES
1674 [ -d SPECS ] || mkdir SPECS
1675 [ -d SRPMS ] || mkdir SRPMS
1697 [[ $list\ == *\ $item\ * ]]
1701 #########################################################################
1702 # Generate a backtrace through the call stack.
1706 #########################################################################
1710 local funcname="" sourcefile="" lineno="" n
1712 echo "Call stack: (most recent first)"
1713 for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1714 funcname=${FUNCNAME[$n - 1]}
1715 sourcefile=$(basename ${BASH_SOURCE[$n]})
1716 lineno=${BASH_LINENO[$n - 1]}
1720 # Display function arguments
1721 if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1722 local args newarg j p=0
1723 for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1724 newarg=${BASH_ARGV[$j + $p - 1]}
1725 args="${args:+${args} }'${newarg}'"
1727 let p+=${BASH_ARGC[$n - 1]}
1729 echo " ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1733 echo "BEGIN BACKTRACE"
1735 #echo ${BASH_LINENO[*]}
1736 #echo ${BASH_SOURCE[*]}
1737 #echo ${FUNCNAME[*]}
1738 local i=$((${#FUNCNAME[@]} - 1))
1739 while [ $i -ge 0 ]; do
1740 local lineno=${BASH_LINENO[$i]}
1744 local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1745 # Can't figure out how to get function args from other frames...
1746 local FUNCTION="${FUNCNAME[$i]}()"
1747 echo "$SOURCELINE:$FUNCTION"
1751 echo "END BACKTRACE"
1757 seen_list=$(new_list)
1759 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1760 Unfortunately the above line number in the message may or may not be correct,
1761 but details have been send to the lbuild maintainer. Attempting to continue."; (echo "Untrapped error"
1763 # have we seen this one
1764 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1766 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1767 echo "seen this one already"
1769 seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1772 ) ; set $xtrace' ERR
1775 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1777 options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ccache,norpm,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-version:,publish,disable-zfs,release,set-value:,src,stage:,target:,target-archs:,with-linux:,xen -- "$@")
1779 if [ $? != 0 ]; then
1783 eval set -- "$options"
1814 if ! KERNELTREE=$(canon_path "$2"); then
1815 fatal 1 "Could not determine the canonical location of $2"
1819 --linux | --with-linux)
1820 if ! LINUX=$(canon_path "$2"); then
1821 fatal 1 "Could not determine the canonical location of $2"
1830 if ! REUSEBUILD=$(canon_path "$2"); then
1831 fatal 1 "Could not determine the canonical location of $2"
1847 if ! KERNELRPMSBASE=$(canon_path "$2"); then
1848 fatal 1 "Could not determine the canonical location of $2"
1857 if ! LUSTRE=$(canon_filepath "$2"); then
1858 fatal 1 "Could not determine the canonical location of $2"
1911 # there are actually some lustre configure flags that we need to
1912 # handle ourselves (but we still give them to configure)
1913 if [[ \ $@\ == *\ --disable-tests\ * ]]; then
1920 usage 1 "Unrecognized option: $1"
1931 if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
1933 unpack_ofed || fatal 1 "Error unpacking OFED tarball"
1936 # make sure the RPM build environment is set up
1937 create_rpmbuild_dirs
1939 # if an unpacked kernel source tree was given on the command line
1940 # just build lustre with it (nothing distro kernel specific here)
1941 if [ -n "$LINUX" ]; then
1942 find_linux_release() {
1943 _find_linux_release $LINUX
1945 build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1946 fatal 1 "error building OFED"
1947 build_lustre "$LINUX" "$LINUXOBJ"
1949 if [ ! -f "${LBUILD_DIR}/lbuild-$DISTROMAJ" ]; then
1950 fatal 1 "${LBUILD_DIR}/lbuild-$DISTROMAJ not found"
1952 source ${LBUILD_DIR}/lbuild-$DISTROMAJ
1953 build_with_srpm || fatal 1 "Failed to build_with_srpm"